AbstractDOMParser (Xerces2 Implementation)
Date: 2018-10-17

org.apache.xerces.parsers

## Class AbstractDOMParser

- java.lang.Object
- - org.apache.xerces.parsers.XMLParser
  - - org.apache.xerces.parsers.AbstractXMLDocumentParser
    - - org.apache.xerces.parsers.AbstractDOMParser

- All Implemented Interfaces:
    org.apache.xerces.xni.XMLDocumentHandler, org.apache.xerces.xni.XMLDTDContentModelHandler, org.apache.xerces.xni.XMLDTDHandler
  Direct Known Subclasses:
    DOMParser, DOMParserImpl

      public class AbstractDOMParser
      extends AbstractXMLDocumentParser

  This is the base class of all DOM parsers. It implements the XNI callback methods to create the DOM tree. After a successful parse of an XML document, the DOM Document object can be queried using the `getDocument` method. The actual pipeline is defined in parser configuration.
  Version:
    $Id: AbstractDOMParser.java 782187 2009-06-06 04:21:12Z mrglavas $
  Author:
    Arnaud Le Hors, IBM, Andy Clark, IBM, Elena Litani, IBM

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static java.lang.String` | `CORE_DOCUMENT_CLASS_NAME`
    `protected static java.lang.String` | `CREATE_CDATA_NODES_FEATURE` Feature id: create cdata nodes.
    `protected static java.lang.String` | `CREATE_ENTITY_REF_NODES` Feature id: create entity ref nodes.
    `protected static java.lang.String` | `CURRENT_ELEMENT_NODE`
    `protected static java.lang.String` | `DEFAULT_DOCUMENT_CLASS_NAME` Default document class name.
    `protected static java.lang.String` | `DEFER_NODE_EXPANSION` Feature id: defer node expansion.
    `protected static java.lang.String` | `DOCUMENT_CLASS_NAME` Property id: document class name.
    `protected java.util.Stack` | `fBaseURIStack` Base uri stack
    `protected boolean` | `fCreateCDATANodes` Create cdata nodes.
    `protected boolean` | `fCreateEntityRefNodes` Create entity reference nodes.
    `protected org.w3c.dom.CDATASection` | `fCurrentCDATASection`
    `protected int` | `fCurrentCDATASectionIndex`
    `protected EntityImpl` | `fCurrentEntityDecl`
    `protected org.w3c.dom.Node` | `fCurrentNode` Current node.
    `protected int` | `fCurrentNodeIndex`
    `protected boolean` | `fDeferNodeExpansion`
    `protected DeferredDocumentImpl` | `fDeferredDocumentImpl`
    `protected int` | `fDeferredEntityDecl`
    `protected org.w3c.dom.Document` | `fDocument` The document.
    `protected java.lang.String` | `fDocumentClassName` The document class name to use.
    `protected CoreDocumentImpl` | `fDocumentImpl` The default Xerces document implementation, if used.
    `protected int` | `fDocumentIndex`
    `protected org.w3c.dom.DocumentType` | `fDocumentType` The document type node.
    `protected int` | `fDocumentTypeIndex`
    `protected org.w3c.dom.ls.LSParserFilter` | `fDOMFilter`
    `protected DOMErrorHandlerWrapper` | `fErrorHandler` DOM L3 error handler
    `protected boolean` | `fFilterReject` LSParserFilter: specifies that element with given QNAME and all its children must be rejected
    `protected boolean` | `fFirstChunk` True if saw the first chunk of characters
    `protected boolean` | `fInCDATASection` True if inside CDATA section.
    `protected boolean` | `fIncludeComments` Include Comments.
    `protected boolean` | `fIncludeIgnorableWhitespace` Include ignorable whitespace.
    `protected boolean` | `fInDTD` True if inside DTD.
    `protected boolean` | `fInDTDExternalSubset` True if inside DTD external subset.
    `protected boolean` | `fInEntityRef` LSParserFilter: true if inside entity reference
    `protected java.lang.StringBuffer` | `fInternalSubset` Internal subset buffer.
    `protected boolean` | `fNamespaceAware`
    `protected int` | `fRejectedElementDepth` LSParserFilter: tracks the element depth within a rejected subtree.
    `protected org.w3c.dom.Node` | `fRoot` Root element node.
    `protected java.util.Stack` | `fSkippedElemStack` LSParserFilter: store depth of skipped elements
    `protected boolean` | `fStorePSVI` Whether to store PSVI information in DOM tree.
    `protected java.lang.StringBuffer` | `fStringBuffer` Character buffer
    `protected static java.lang.String` | `INCLUDE_COMMENTS_FEATURE` Feature id: include comments.
    `protected static java.lang.String` | `INCLUDE_IGNORABLE_WHITESPACE` Feature id: include ignorable whitespace.
    `protected static java.lang.String` | `NAMESPACES` Feature id: namespace.
    `protected static java.lang.String` | `PSVI_DOCUMENT_CLASS_NAME`

    - ### Fields inherited from class org.apache.xerces.parsers.AbstractXMLDocumentParser

      `fDocumentSource, fDTDContentModelSource, fDTDSource`

    - ### Fields inherited from class org.apache.xerces.parsers.XMLParser

      `ENTITY_RESOLVER, ERROR_HANDLER, fConfiguration`

    - ### Fields inherited from interface org.apache.xerces.xni.XMLDTDHandler

      `CONDITIONAL_IGNORE, CONDITIONAL_INCLUDE`

    - ### Fields inherited from interface org.apache.xerces.xni.XMLDTDContentModelHandler

      `OCCURS_ONE_OR_MORE, OCCURS_ZERO_OR_MORE, OCCURS_ZERO_OR_ONE, SEPARATOR_CHOICE, SEPARATOR_SEQUENCE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractDOMParser(org.apache.xerces.xni.parser.XMLParserConfiguration config)` Default constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `abort()`
    `void` | `attributeDecl(java.lang.String elementName, java.lang.String attributeName, java.lang.String type, java.lang.String[] enumeration, java.lang.String defaultType, org.apache.xerces.xni.XMLString defaultValue, org.apache.xerces.xni.XMLString nonNormalizedDefaultValue, org.apache.xerces.xni.Augmentations augs)` An attribute declaration.
    `void` | `characters(org.apache.xerces.xni.XMLString text, org.apache.xerces.xni.Augmentations augs)` Character content.
    `void` | `comment(org.apache.xerces.xni.XMLString text, org.apache.xerces.xni.Augmentations augs)` A comment.
    `protected org.w3c.dom.Attr` | `createAttrNode(org.apache.xerces.xni.QName attrQName)`
    `protected org.w3c.dom.Element` | `createElementNode(org.apache.xerces.xni.QName element)`
    `void` | `doctypeDecl(java.lang.String rootElement, java.lang.String publicId, java.lang.String systemId, org.apache.xerces.xni.Augmentations augs)` Notifies of the presence of the DOCTYPE line in the document.
    `void` | `dropDocumentReferences()` Drops all references to the last DOM which was built by this parser.
    `void` | `elementDecl(java.lang.String name, java.lang.String contentModel, org.apache.xerces.xni.Augmentations augs)` An element declaration.
    `void` | `emptyElement(org.apache.xerces.xni.QName element, org.apache.xerces.xni.XMLAttributes attributes, org.apache.xerces.xni.Augmentations augs)` An empty element.
    `void` | `endAttlist(org.apache.xerces.xni.Augmentations augs)` The end of an attribute list.
    `void` | `endCDATA(org.apache.xerces.xni.Augmentations augs)` The end of a CDATA section.
    `void` | `endConditional(org.apache.xerces.xni.Augmentations augs)` The end of a conditional section.
    `void` | `endDocument(org.apache.xerces.xni.Augmentations augs)` The end of the document.
    `void` | `endDTD(org.apache.xerces.xni.Augmentations augs)` The end of the DTD.
    `void` | `endElement(org.apache.xerces.xni.QName element, org.apache.xerces.xni.Augmentations augs)` The end of an element.
    `void` | `endExternalSubset(org.apache.xerces.xni.Augmentations augs)` The end of the DTD external subset.
    `void` | `endGeneralEntity(java.lang.String name, org.apache.xerces.xni.Augmentations augs)` This method notifies the end of a general entity.
    `void` | `endParameterEntity(java.lang.String name, org.apache.xerces.xni.Augmentations augs)` This method notifies the end of a parameter entity.
    `void` | `externalEntityDecl(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, org.apache.xerces.xni.Augmentations augs)` An external entity declaration.
    `org.w3c.dom.Document` | `getDocument()` Returns the DOM document object.
    `protected java.lang.String` | `getDocumentClassName()` This method retreives the name of current document class.
    `protected void` | `handleBaseURI(int node)` Record baseURI information for the Element (by adding xml:base attribute) or for the ProcessingInstruction (by setting a baseURI field) Deferred DOM.
    `protected void` | `handleBaseURI(org.w3c.dom.Node node)` Record baseURI information for the Element (by adding xml:base attribute) or for the ProcessingInstruction (by setting a baseURI field) Non deferred DOM.
    `void` | `ignorableWhitespace(org.apache.xerces.xni.XMLString text, org.apache.xerces.xni.Augmentations augs)` Ignorable whitespace.
    `void` | `ignoredCharacters(org.apache.xerces.xni.XMLString text, org.apache.xerces.xni.Augmentations augs)` Characters within an IGNORE conditional section.
    `void` | `internalEntityDecl(java.lang.String name, org.apache.xerces.xni.XMLString text, org.apache.xerces.xni.XMLString nonNormalizedText, org.apache.xerces.xni.Augmentations augs)` An internal entity declaration.
    `void` | `notationDecl(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, org.apache.xerces.xni.Augmentations augs)` A notation declaration
    `void` | `processingInstruction(java.lang.String target, org.apache.xerces.xni.XMLString data, org.apache.xerces.xni.Augmentations augs)` A processing instruction.
    `void` | `reset()` Resets the parser state.
    `protected void` | `setCharacterData(boolean sawChars)`
    `protected void` | `setDocumentClassName(java.lang.String documentClassName)` This method allows the programmer to decide which document factory to use when constructing the DOM tree.
    `void` | `setLocale(java.util.Locale locale)` Set the locale to use for messages.
    `void` | `startAttlist(java.lang.String elementName, org.apache.xerces.xni.Augmentations augs)` The start of an attribute list.
    `void` | `startCDATA(org.apache.xerces.xni.Augmentations augs)` The start of a CDATA section.
    `void` | `startConditional(short type, org.apache.xerces.xni.Augmentations augs)` The start of a conditional section.
    `void` | `startDocument(org.apache.xerces.xni.XMLLocator locator, java.lang.String encoding, org.apache.xerces.xni.NamespaceContext namespaceContext, org.apache.xerces.xni.Augmentations augs)` The start of the document.
    `void` | `startDTD(org.apache.xerces.xni.XMLLocator locator, org.apache.xerces.xni.Augmentations augs)` The start of the DTD.
    `void` | `startElement(org.apache.xerces.xni.QName element, org.apache.xerces.xni.XMLAttributes attributes, org.apache.xerces.xni.Augmentations augs)` The start of an element.
    `void` | `startExternalSubset(org.apache.xerces.xni.XMLResourceIdentifier identifier, org.apache.xerces.xni.Augmentations augs)` The start of the DTD external subset.
    `void` | `startGeneralEntity(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, java.lang.String encoding, org.apache.xerces.xni.Augmentations augs)` This method notifies the start of a general entity.
    `void` | `startParameterEntity(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, java.lang.String encoding, org.apache.xerces.xni.Augmentations augs)` This method notifies of the start of a parameter entity.
    `void` | `textDecl(java.lang.String version, java.lang.String encoding, org.apache.xerces.xni.Augmentations augs)` Notifies of the presence of a TextDecl line in an entity.
    `void` | `unparsedEntityDecl(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, java.lang.String notation, org.apache.xerces.xni.Augmentations augs)` An unparsed entity declaration.
    `void` | `xmlDecl(java.lang.String version, java.lang.String encoding, java.lang.String standalone, org.apache.xerces.xni.Augmentations augs)` Notifies of the presence of an XMLDecl line in the document.

    - ### Methods inherited from class org.apache.xerces.parsers.AbstractXMLDocumentParser

      `any, element, empty, endContentModel, endGroup, getDocumentSource, getDTDContentModelSource, getDTDSource, occurrence, pcdata, separator, setDocumentSource, setDTDContentModelSource, setDTDSource, startContentModel, startGroup`

    - ### Methods inherited from class org.apache.xerces.parsers.XMLParser

      `parse`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NAMESPACES

          protected static final java.lang.String NAMESPACES

      Feature id: namespace.
      See Also:
        Constant Field Values

    - #### CREATE_ENTITY_REF_NODES

          protected static final java.lang.String CREATE_ENTITY_REF_NODES

      Feature id: create entity ref nodes.
      See Also:
        Constant Field Values

    - #### INCLUDE_COMMENTS_FEATURE

          protected static final java.lang.String INCLUDE_COMMENTS_FEATURE

      Feature id: include comments.
      See Also:
        Constant Field Values

    - #### CREATE_CDATA_NODES_FEATURE

          protected static final java.lang.String CREATE_CDATA_NODES_FEATURE

      Feature id: create cdata nodes.
      See Also:
        Constant Field Values

    - #### INCLUDE_IGNORABLE_WHITESPACE

          protected static final java.lang.String INCLUDE_IGNORABLE_WHITESPACE

      Feature id: include ignorable whitespace.
      See Also:
        Constant Field Values

    - #### DEFER_NODE_EXPANSION

          protected static final java.lang.String DEFER_NODE_EXPANSION

      Feature id: defer node expansion.
      See Also:
        Constant Field Values

    - #### DOCUMENT_CLASS_NAME

          protected static final java.lang.String DOCUMENT_CLASS_NAME

      Property id: document class name.
      See Also:
        Constant Field Values

    - #### CURRENT_ELEMENT_NODE

          protected static final java.lang.String CURRENT_ELEMENT_NODE

      See Also:
        Constant Field Values

    - #### DEFAULT_DOCUMENT_CLASS_NAME

          protected static final java.lang.String DEFAULT_DOCUMENT_CLASS_NAME

      Default document class name.
      See Also:
        Constant Field Values

    - #### CORE_DOCUMENT_CLASS_NAME

          protected static final java.lang.String CORE_DOCUMENT_CLASS_NAME

      See Also:
        Constant Field Values

    - #### PSVI_DOCUMENT_CLASS_NAME

          protected static final java.lang.String PSVI_DOCUMENT_CLASS_NAME

      See Also:
        Constant Field Values

    - #### fErrorHandler

          protected DOMErrorHandlerWrapper fErrorHandler

      DOM L3 error handler

    - #### fInDTD

          protected boolean fInDTD

      True if inside DTD.

    - #### fCreateEntityRefNodes

          protected boolean fCreateEntityRefNodes

      Create entity reference nodes.

    - #### fIncludeIgnorableWhitespace

          protected boolean fIncludeIgnorableWhitespace

      Include ignorable whitespace.

    - #### fIncludeComments

          protected boolean fIncludeComments

      Include Comments.

    - #### fCreateCDATANodes

          protected boolean fCreateCDATANodes

      Create cdata nodes.

    - #### fDocument

          protected org.w3c.dom.Document fDocument

      The document.

    - #### fDocumentImpl

          protected CoreDocumentImpl fDocumentImpl

      The default Xerces document implementation, if used.

    - #### fStorePSVI

          protected boolean fStorePSVI

      Whether to store PSVI information in DOM tree.

    - #### fDocumentClassName

          protected java.lang.String fDocumentClassName

      The document class name to use.

    - #### fDocumentType

          protected org.w3c.dom.DocumentType fDocumentType

      The document type node.

    - #### fCurrentNode

          protected org.w3c.dom.Node fCurrentNode

      Current node.

    - #### fCurrentCDATASection

          protected org.w3c.dom.CDATASection fCurrentCDATASection

    - #### fCurrentEntityDecl

          protected EntityImpl fCurrentEntityDecl

    - #### fDeferredEntityDecl

          protected int fDeferredEntityDecl

    - #### fStringBuffer

          protected final java.lang.StringBuffer fStringBuffer

      Character buffer

    - #### fInternalSubset

          protected java.lang.StringBuffer fInternalSubset

      Internal subset buffer.

    - #### fDeferNodeExpansion

          protected boolean fDeferNodeExpansion

    - #### fNamespaceAware

          protected boolean fNamespaceAware

    - #### fDeferredDocumentImpl

          protected DeferredDocumentImpl fDeferredDocumentImpl

    - #### fDocumentIndex

          protected int fDocumentIndex

    - #### fDocumentTypeIndex

          protected int fDocumentTypeIndex

    - #### fCurrentNodeIndex

          protected int fCurrentNodeIndex

    - #### fCurrentCDATASectionIndex

          protected int fCurrentCDATASectionIndex

    - #### fInDTDExternalSubset

          protected boolean fInDTDExternalSubset

      True if inside DTD external subset.

    - #### fRoot

          protected org.w3c.dom.Node fRoot

      Root element node.

    - #### fInCDATASection

          protected boolean fInCDATASection

      True if inside CDATA section.

    - #### fFirstChunk

          protected boolean fFirstChunk

      True if saw the first chunk of characters

    - #### fFilterReject

          protected boolean fFilterReject

      LSParserFilter: specifies that element with given QNAME and all its children must be rejected

    - #### fBaseURIStack

          protected final java.util.Stack fBaseURIStack

      Base uri stack

    - #### fRejectedElementDepth

          protected int fRejectedElementDepth

      LSParserFilter: tracks the element depth within a rejected subtree.

    - #### fSkippedElemStack

          protected java.util.Stack fSkippedElemStack

      LSParserFilter: store depth of skipped elements

    - #### fInEntityRef

          protected boolean fInEntityRef

      LSParserFilter: true if inside entity reference

    - #### fDOMFilter

          protected org.w3c.dom.ls.LSParserFilter fDOMFilter

  - ### Constructor Detail

    - #### AbstractDOMParser

          protected AbstractDOMParser(org.apache.xerces.xni.parser.XMLParserConfiguration config)

      Default constructor.

  - ### Method Detail

    - #### getDocumentClassName

          protected java.lang.String getDocumentClassName()

      This method retreives the name of current document class.

    - #### setDocumentClassName

          protected void setDocumentClassName(java.lang.String documentClassName)

      This method allows the programmer to decide which document factory to use when constructing the DOM tree. However, doing so will lose the functionality of the default factory. Also, a document class other than the default will lose the ability to defer node expansion on the DOM tree produced.
      Parameters:
        `documentClassName` - The fully qualified class name of the document factory to use when constructing the DOM tree.
      See Also:
        `getDocumentClassName()`, `DEFAULT_DOCUMENT_CLASS_NAME`

    - #### getDocument

          public org.w3c.dom.Document getDocument()

      Returns the DOM document object.

    - #### dropDocumentReferences

          public final void dropDocumentReferences()

      Drops all references to the last DOM which was built by this parser.

    - #### reset

          public void reset()
                     throws org.apache.xerces.xni.XNIException

      Resets the parser state.
      Overrides:
        `reset` in class `AbstractXMLDocumentParser`
      Throws:
        `org.xml.sax.SAXException` - Thrown on initialization error.
        `org.apache.xerces.xni.XNIException`

    - #### setLocale

          public void setLocale(java.util.Locale locale)

      Set the locale to use for messages.
      Parameters:
        `locale` - The locale object to use for localization of messages.

    - #### startGeneralEntity

          public void startGeneralEntity(java.lang.String name,
                                         org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                         java.lang.String encoding,
                                         org.apache.xerces.xni.Augmentations augs)
                                  throws org.apache.xerces.xni.XNIException

      This method notifies the start of a general entity.

      Note: This method is not called for entity references appearing as part of attribute values.

      Specified by:
        `startGeneralEntity` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `startGeneralEntity` in class `AbstractXMLDocumentParser`
      Parameters:
        `name` - The name of the general entity.
        `identifier` - The resource identifier.
        `encoding` - The auto-detected IANA encoding name of the entity stream. This value will be null in those situations where the entity encoding is not auto-detected (e.g. internal entities or a document entity that is parsed from a java.io.Reader).
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### textDecl

          public void textDecl(java.lang.String version,
                               java.lang.String encoding,
                               org.apache.xerces.xni.Augmentations augs)
                        throws org.apache.xerces.xni.XNIException

      Notifies of the presence of a TextDecl line in an entity. If present, this method will be called immediately following the startEntity call.

      Note: This method will never be called for the document entity; it is only called for external general entities referenced in document content.

      Note: This method is not called for entity references appearing as part of attribute values.

      Specified by:
        `textDecl` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Specified by:
        `textDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `textDecl` in class `AbstractXMLDocumentParser`
      Parameters:
        `version` - The XML version, or null if not specified.
        `encoding` - The IANA encoding name of the entity.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### comment

          public void comment(org.apache.xerces.xni.XMLString text,
                              org.apache.xerces.xni.Augmentations augs)
                       throws org.apache.xerces.xni.XNIException

      A comment.
      Specified by:
        `comment` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Specified by:
        `comment` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `comment` in class `AbstractXMLDocumentParser`
      Parameters:
        `text` - The text in the comment.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by application to signal an error.

    - #### processingInstruction

          public void processingInstruction(java.lang.String target,
                                            org.apache.xerces.xni.XMLString data,
                                            org.apache.xerces.xni.Augmentations augs)
                                     throws org.apache.xerces.xni.XNIException

      A processing instruction. Processing instructions consist of a target name and, optionally, text data. The data is only meaningful to the application.

      Typically, a processing instruction's data will contain a series of pseudo-attributes. These pseudo-attributes follow the form of element attributes but are not parsed or presented to the application as anything other than text. The application is responsible for parsing the data.

      Specified by:
        `processingInstruction` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Specified by:
        `processingInstruction` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `processingInstruction` in class `AbstractXMLDocumentParser`
      Parameters:
        `target` - The target.
        `data` - The data or null if none specified.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startDocument

          public void startDocument(org.apache.xerces.xni.XMLLocator locator,
                                    java.lang.String encoding,
                                    org.apache.xerces.xni.NamespaceContext namespaceContext,
                                    org.apache.xerces.xni.Augmentations augs)
                             throws org.apache.xerces.xni.XNIException

      The start of the document.
      Specified by:
        `startDocument` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `startDocument` in class `AbstractXMLDocumentParser`
      Parameters:
        `locator` - The system identifier of the entity if the entity is external, null otherwise.
        `encoding` - The auto-detected IANA encoding name of the entity stream. This value will be null in those situations where the entity encoding is not auto-detected (e.g. internal entities or a document entity that is parsed from a java.io.Reader).
        `namespaceContext` - The namespace context in effect at the start of this document. This object represents the current context. Implementors of this class are responsible for copying the namespace bindings from the the current context (and its parent contexts) if that information is important.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### xmlDecl

          public void xmlDecl(java.lang.String version,
                              java.lang.String encoding,
                              java.lang.String standalone,
                              org.apache.xerces.xni.Augmentations augs)
                       throws org.apache.xerces.xni.XNIException

      Notifies of the presence of an XMLDecl line in the document. If present, this method will be called immediately following the startDocument call.
      Specified by:
        `xmlDecl` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `xmlDecl` in class `AbstractXMLDocumentParser`
      Parameters:
        `version` - The XML version.
        `encoding` - The IANA encoding name of the document, or null if not specified.
        `standalone` - The standalone value, or null if not specified.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### doctypeDecl

          public void doctypeDecl(java.lang.String rootElement,
                                  java.lang.String publicId,
                                  java.lang.String systemId,
                                  org.apache.xerces.xni.Augmentations augs)
                           throws org.apache.xerces.xni.XNIException

      Notifies of the presence of the DOCTYPE line in the document.
      Specified by:
        `doctypeDecl` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `doctypeDecl` in class `AbstractXMLDocumentParser`
      Parameters:
        `rootElement` - The name of the root element.
        `publicId` - The public identifier if an external DTD or null if the external DTD is specified using SYSTEM.
        `systemId` - The system identifier if an external DTD, null otherwise.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startElement

          public void startElement(org.apache.xerces.xni.QName element,
                                   org.apache.xerces.xni.XMLAttributes attributes,
                                   org.apache.xerces.xni.Augmentations augs)
                            throws org.apache.xerces.xni.XNIException

      The start of an element. If the document specifies the start element by using an empty tag, then the startElement method will immediately be followed by the endElement method, with no intervening methods.
      Specified by:
        `startElement` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `startElement` in class `AbstractXMLDocumentParser`
      Parameters:
        `element` - The name of the element.
        `attributes` - The element attributes.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### emptyElement

          public void emptyElement(org.apache.xerces.xni.QName element,
                                   org.apache.xerces.xni.XMLAttributes attributes,
                                   org.apache.xerces.xni.Augmentations augs)
                            throws org.apache.xerces.xni.XNIException

      An empty element.
      Specified by:
        `emptyElement` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `emptyElement` in class `AbstractXMLDocumentParser`
      Parameters:
        `element` - The name of the element.
        `attributes` - The element attributes.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### characters

          public void characters(org.apache.xerces.xni.XMLString text,
                                 org.apache.xerces.xni.Augmentations augs)
                          throws org.apache.xerces.xni.XNIException

      Character content.
      Specified by:
        `characters` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `characters` in class `AbstractXMLDocumentParser`
      Parameters:
        `text` - The content.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### ignorableWhitespace

          public void ignorableWhitespace(org.apache.xerces.xni.XMLString text,
                                          org.apache.xerces.xni.Augmentations augs)
                                   throws org.apache.xerces.xni.XNIException

      Ignorable whitespace. For this method to be called, the document source must have some way of determining that the text containing only whitespace characters should be considered ignorable. For example, the validator can determine if a length of whitespace characters in the document are ignorable based on the element content model.
      Specified by:
        `ignorableWhitespace` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `ignorableWhitespace` in class `AbstractXMLDocumentParser`
      Parameters:
        `text` - The ignorable whitespace.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endElement

          public void endElement(org.apache.xerces.xni.QName element,
                                 org.apache.xerces.xni.Augmentations augs)
                          throws org.apache.xerces.xni.XNIException

      The end of an element.
      Specified by:
        `endElement` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `endElement` in class `AbstractXMLDocumentParser`
      Parameters:
        `element` - The name of the element.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startCDATA

          public void startCDATA(org.apache.xerces.xni.Augmentations augs)
                          throws org.apache.xerces.xni.XNIException

      The start of a CDATA section.
      Specified by:
        `startCDATA` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `startCDATA` in class `AbstractXMLDocumentParser`
      Parameters:
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endCDATA

          public void endCDATA(org.apache.xerces.xni.Augmentations augs)
                        throws org.apache.xerces.xni.XNIException

      The end of a CDATA section.
      Specified by:
        `endCDATA` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `endCDATA` in class `AbstractXMLDocumentParser`
      Parameters:
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endDocument

          public void endDocument(org.apache.xerces.xni.Augmentations augs)
                           throws org.apache.xerces.xni.XNIException

      The end of the document.
      Specified by:
        `endDocument` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `endDocument` in class `AbstractXMLDocumentParser`
      Parameters:
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endGeneralEntity

          public void endGeneralEntity(java.lang.String name,
                                       org.apache.xerces.xni.Augmentations augs)
                                throws org.apache.xerces.xni.XNIException

      This method notifies the end of a general entity.

      Note: This method is not called for entity references appearing as part of attribute values.

      Specified by:
        `endGeneralEntity` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Overrides:
        `endGeneralEntity` in class `AbstractXMLDocumentParser`
      Parameters:
        `name` - The name of the entity.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### handleBaseURI

          protected final void handleBaseURI(org.w3c.dom.Node node)

      Record baseURI information for the Element (by adding xml:base attribute) or for the ProcessingInstruction (by setting a baseURI field) Non deferred DOM.
      Parameters:
        `node` -

    - #### handleBaseURI

          protected final void handleBaseURI(int node)

      Record baseURI information for the Element (by adding xml:base attribute) or for the ProcessingInstruction (by setting a baseURI field) Deferred DOM.
      Parameters:
        `node` -

    - #### startDTD

          public void startDTD(org.apache.xerces.xni.XMLLocator locator,
                               org.apache.xerces.xni.Augmentations augs)
                        throws org.apache.xerces.xni.XNIException

      The start of the DTD.
      Specified by:
        `startDTD` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `startDTD` in class `AbstractXMLDocumentParser`
      Parameters:
        `locator` - The document locator, or null if the document location cannot be reported during the parsing of the document DTD. However, it is strongly recommended that a locator be supplied that can at least report the base system identifier of the DTD.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endDTD

          public void endDTD(org.apache.xerces.xni.Augmentations augs)
                      throws org.apache.xerces.xni.XNIException

      The end of the DTD.
      Specified by:
        `endDTD` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `endDTD` in class `AbstractXMLDocumentParser`
      Parameters:
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startConditional

          public void startConditional(short type,
                                       org.apache.xerces.xni.Augmentations augs)
                                throws org.apache.xerces.xni.XNIException

      The start of a conditional section.
      Specified by:
        `startConditional` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `startConditional` in class `AbstractXMLDocumentParser`
      Parameters:
        `type` - The type of the conditional section. This value will either be CONDITIONAL_INCLUDE or CONDITIONAL_IGNORE.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.
      See Also:
        `XMLDTDHandler.CONDITIONAL_INCLUDE`, `XMLDTDHandler.CONDITIONAL_IGNORE`

    - #### endConditional

          public void endConditional(org.apache.xerces.xni.Augmentations augs)
                              throws org.apache.xerces.xni.XNIException

      The end of a conditional section.
      Specified by:
        `endConditional` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `endConditional` in class `AbstractXMLDocumentParser`
      Parameters:
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startExternalSubset

          public void startExternalSubset(org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                          org.apache.xerces.xni.Augmentations augs)
                                   throws org.apache.xerces.xni.XNIException

      The start of the DTD external subset.
      Specified by:
        `startExternalSubset` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `startExternalSubset` in class `AbstractXMLDocumentParser`
      Parameters:
        `augs` - Additional information that may include infoset augmentations.
        `identifier` - The resource identifier.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endExternalSubset

          public void endExternalSubset(org.apache.xerces.xni.Augmentations augs)
                                 throws org.apache.xerces.xni.XNIException

      The end of the DTD external subset.
      Specified by:
        `endExternalSubset` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `endExternalSubset` in class `AbstractXMLDocumentParser`
      Parameters:
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### internalEntityDecl

          public void internalEntityDecl(java.lang.String name,
                                         org.apache.xerces.xni.XMLString text,
                                         org.apache.xerces.xni.XMLString nonNormalizedText,
                                         org.apache.xerces.xni.Augmentations augs)
                                  throws org.apache.xerces.xni.XNIException

      An internal entity declaration.
      Specified by:
        `internalEntityDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `internalEntityDecl` in class `AbstractXMLDocumentParser`
      Parameters:
        `name` - The name of the entity. Parameter entity names start with '%', whereas the name of a general entity is just the entity name.
        `text` - The value of the entity.
        `nonNormalizedText` - The non-normalized value of the entity. This value contains the same sequence of characters that was in the internal entity declaration, without any entity references expanded.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### externalEntityDecl

          public void externalEntityDecl(java.lang.String name,
                                         org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                         org.apache.xerces.xni.Augmentations augs)
                                  throws org.apache.xerces.xni.XNIException

      An external entity declaration.
      Specified by:
        `externalEntityDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `externalEntityDecl` in class `AbstractXMLDocumentParser`
      Parameters:
        `name` - The name of the entity. Parameter entity names start with '%', whereas the name of a general entity is just the entity name.
        `identifier` - An object containing all location information pertinent to this notation.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startParameterEntity

          public void startParameterEntity(java.lang.String name,
                                           org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                           java.lang.String encoding,
                                           org.apache.xerces.xni.Augmentations augs)
                                    throws org.apache.xerces.xni.XNIException

      This method notifies of the start of a parameter entity. The parameter entity name start with a '%' character.
      Specified by:
        `startParameterEntity` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `startParameterEntity` in class `AbstractXMLDocumentParser`
      Parameters:
        `name` - The name of the parameter entity.
        `identifier` - The resource identifier.
        `encoding` - The auto-detected IANA encoding name of the entity stream. This value will be null in those situations where the entity encoding is not auto-detected (e.g. internal parameter entities).
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endParameterEntity

          public void endParameterEntity(java.lang.String name,
                                         org.apache.xerces.xni.Augmentations augs)
                                  throws org.apache.xerces.xni.XNIException

      This method notifies the end of a parameter entity. Parameter entity names begin with a '%' character.
      Specified by:
        `endParameterEntity` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `endParameterEntity` in class `AbstractXMLDocumentParser`
      Parameters:
        `name` - The name of the parameter entity.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### unparsedEntityDecl

          public void unparsedEntityDecl(java.lang.String name,
                                         org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                         java.lang.String notation,
                                         org.apache.xerces.xni.Augmentations augs)
                                  throws org.apache.xerces.xni.XNIException

      An unparsed entity declaration.
      Specified by:
        `unparsedEntityDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `unparsedEntityDecl` in class `AbstractXMLDocumentParser`
      Parameters:
        `name` - The name of the entity.
        `identifier` - An object containing all location information pertinent to this entity.
        `notation` - The name of the notation.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### notationDecl

          public void notationDecl(java.lang.String name,
                                   org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                   org.apache.xerces.xni.Augmentations augs)
                            throws org.apache.xerces.xni.XNIException

      A notation declaration
      Specified by:
        `notationDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `notationDecl` in class `AbstractXMLDocumentParser`
      Parameters:
        `name` - The name of the notation.
        `identifier` - An object containing all location information pertinent to this notation.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### ignoredCharacters

          public void ignoredCharacters(org.apache.xerces.xni.XMLString text,
                                        org.apache.xerces.xni.Augmentations augs)
                                 throws org.apache.xerces.xni.XNIException

      Characters within an IGNORE conditional section.
      Specified by:
        `ignoredCharacters` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `ignoredCharacters` in class `AbstractXMLDocumentParser`
      Parameters:
        `text` - The ignored text.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### elementDecl

          public void elementDecl(java.lang.String name,
                                  java.lang.String contentModel,
                                  org.apache.xerces.xni.Augmentations augs)
                           throws org.apache.xerces.xni.XNIException

      An element declaration.
      Specified by:
        `elementDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `elementDecl` in class `AbstractXMLDocumentParser`
      Parameters:
        `name` - The name of the element.
        `contentModel` - The element content model.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### attributeDecl

          public void attributeDecl(java.lang.String elementName,
                                    java.lang.String attributeName,
                                    java.lang.String type,
                                    java.lang.String[] enumeration,
                                    java.lang.String defaultType,
                                    org.apache.xerces.xni.XMLString defaultValue,
                                    org.apache.xerces.xni.XMLString nonNormalizedDefaultValue,
                                    org.apache.xerces.xni.Augmentations augs)
                             throws org.apache.xerces.xni.XNIException

      An attribute declaration.
      Specified by:
        `attributeDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `attributeDecl` in class `AbstractXMLDocumentParser`
      Parameters:
        `elementName` - The name of the element that this attribute is associated with.
        `attributeName` - The name of the attribute.
        `type` - The attribute type. This value will be one of the following: "CDATA", "ENTITY", "ENTITIES", "ENUMERATION", "ID", "IDREF", "IDREFS", "NMTOKEN", "NMTOKENS", or "NOTATION".
        `enumeration` - If the type has the value "ENUMERATION" or "NOTATION", this array holds the allowed attribute values; otherwise, this array is null.
        `defaultType` - The attribute default type. This value will be one of the following: "#FIXED", "#IMPLIED", "#REQUIRED", or null.
        `defaultValue` - The attribute default value, or null if no default value is specified.
        `nonNormalizedDefaultValue` - The attribute default value with no normalization performed, or null if no default value is specified.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startAttlist

          public void startAttlist(java.lang.String elementName,
                                   org.apache.xerces.xni.Augmentations augs)
                            throws org.apache.xerces.xni.XNIException

      The start of an attribute list.
      Specified by:
        `startAttlist` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `startAttlist` in class `AbstractXMLDocumentParser`
      Parameters:
        `elementName` - The name of the element that this attribute list is associated with.
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endAttlist

          public void endAttlist(org.apache.xerces.xni.Augmentations augs)
                          throws org.apache.xerces.xni.XNIException

      The end of an attribute list.
      Specified by:
        `endAttlist` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Overrides:
        `endAttlist` in class `AbstractXMLDocumentParser`
      Parameters:
        `augs` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### createElementNode

          protected org.w3c.dom.Element createElementNode(org.apache.xerces.xni.QName element)

    - #### createAttrNode

          protected org.w3c.dom.Attr createAttrNode(org.apache.xerces.xni.QName attrQName)

    - #### setCharacterData

          protected void setCharacterData(boolean sawChars)

    - #### abort

          public void abort()

      See Also:
        `LSParser.abort()`

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.